﻿# -*- coding: utf-8 -*-

import bpy
import nodeitems_utils

#### =======================================================================
class NODE_PT_NodeToSideBar(bpy.types.Panel):
	'''SideBarのタブとして.何もしない'''
	bl_space_type = "NODE_EDITOR"
	bl_region_type= "UI"
	bl_label   = "NodeToSideBar"
	bl_category= "Nodes"
	bl_options = {"HIDE_HEADER"}

	#### --------------------------------
	@classmethod
	def poll(cls, context):
		return(context.active_node != None)

	#### --------------------------------
#	def draw_header(self, context):
#		self.layout.label(text="", icon="NODE")

	#### --------------------------------
	def draw(self, context):
		pass
#		# カテゴリ毎のプルダウンの羅列
#		nodeitems_utils.draw_node_categories_menu(self, context)
		"""
		layout = self.layout
		for (categories, draw_add_menu, menu_types) in nodeitems_utils._node_categories.values():
			for cat in categories:
				if(cat.poll(context)):
					clm = layout.column()
					clm.scale_y = 0.85
					clm.label(text= cat.name)
					c = clm.box().column()	# clm.box.clmにしないと上下に無駄空間が出来る

					clsMenu = getattr(bpy.types, f"NODE_MT_category_{cat.identifier:s}")
					for nd in clsMenu.category.items(context):
						nd.draw(nd, c, context)
#					clm.box().menu_contents(clsName)	# 上記と同義,何重かにwrapさた実行処理
		"""

#### =======================================================================
_nodes = {}

#### --------------------------------
#def Fn_Draw_Header(self, context):
#	'''iconを付けないなら不要, bl_labelがヘッダに使われる'''
#	self.layout.label(text="", icon="NODE")

#### --------------------------------
def Fn_Draw(self, context):
	for (categories, draw_add_menu, menu_types) in nodeitems_utils._node_categories.values():
		for cat in categories:
			if(cat.poll(context) and (self.bl_label == cat.name)):
				clm = self.layout.column()
				clm.scale_y = 0.85

				clsMenu = getattr(bpy.types, f"NODE_MT_category_{cat.identifier:s}")
				for nd in clsMenu.category.items(context):
					nd.draw(nd, clm, context)
#				clm.box().menu_contents(clsName)	# 上記と同義,何重かにwrapさた実行処理
				return

#### -----------------------------------------------------------------------
def _MakeSubPanels():
	''' '''
	for (editor_identifier, (categories, draw_add_menu, menu_types)) in nodeitems_utils._node_categories.items():
		clss = []
		for cat in categories:
			cls = type(f"NODE_PT_NodeToSideBar_{cat.identifier:s}", (bpy.types.Panel,), {
				"bl_space_type":  "NODE_EDITOR",
				"bl_region_type": "UI",
				"bl_label": cat.name,
				"bl_category": "Nodes",
				"bl_options": {"DEFAULT_CLOSED"},
				"poll": cat.poll,
#				"draw_header": Fn_Draw_Header,
				"draw": Fn_Draw,
				})
			clss.append(cls)
		_nodes[editor_identifier] = clss

#### =======================================================================
def _Fn_resist(Fn):
	for (editor_identifier, clss) in _nodes.items():
		for cls in clss:
			Fn(cls)

#### -----------------------------------------------------------------------
def register():
	bpy.utils.register_class(NODE_PT_NodeToSideBar)
	if(not _nodes):
		_MakeSubPanels()

	_Fn_resist(bpy.utils.register_class)

#### -----------------------------------------------------------------------
def unregister():
	_Fn_resist(bpy.utils.unregister_class)
